function  funktion  = f(x)
 
 
global n1    
global n2
global n3
global Tmax  % temperature constraint
global k 
global alpha 
global umax  % control constraint
global N     % Number of nodes for k and alpha 
 
 lambda=0.1;
 w0=-6;
 wp0=0;
 
 
 
 
 for j=1:n1
    w1a(j) = x(j);  
    w2a(j) = x(j+n1+n2+n3-2);
    p2a(j) = x(j+2*n1+2*n2+2*n3-3);   
 end 
 
 for j=1:n2
    w1b(j) = x(j+n1-1);
    w2b(j) = x(j+2*n1+n2+n3-3);
    p2b(j) = x(j+3*n1+2*n2+2*n3-4);
    p3b(j) = x(j+3*n1+3*n2+3*n3-4);
 end
 
 for j=1:n3
    w1c(j) = x(j+n1+n2-2);
    w2c(j) = x(j+2*n1+2*n2+n3-4);
    p2c(j) = x(j+3*n1+3*n2+2*n3-5);
 end   
 

 
    p1     = x(2*n1+2*n2+2*n3-3);  % only a constant
    
    p3a    = x(3*n1+3*n2+3*n3-4);  % only a constant
    
    
    ton    = x(3*n1+4*n2+3*n3-3);
    toff   = x(3*n1+4*n2+3*n3-2);
    tf     = x(3*n1+4*n2+3*n3-1);
    mu     = x(3*n1+4*n2+3*n3);



     int1=0;
     for s=1:n1  % Integral for w3a(ton)=Tmax
         if s==1
            int1=int1+0.5*sum(alpha.*w2a(s)^2.*exp(-k.^2*(n1-s)/n1*ton));
         elseif s==n1
            int1=int1+0.5*sum(alpha.*w2a(s)^2.*exp(-k.^2*(n1-s)/n1*ton));
         else    
            int1=int1+sum(alpha.*w2a(s)^2.*exp(-k.^2*(n1-s)/n1*ton));
         end   
     end
     int1=int1/(n1-1)*ton;

 
 for j=1:n1
    int2(j)=0; % Integral for p2a dot 
    for s=1:n2
        if s==1
            int2(j)=int2(j)+0.5*sum(k.^2.*alpha.*exp(-k.^2*((s-1)/(n2-1)*(toff-ton)+ton-j/n1*ton)).*p3b(s));
        elseif s==n2
            int2(j)=int2(j)+0.5*sum(k.^2.*alpha.*exp(-k.^2*((s-1)/(n2-1)*(toff-ton)+ton-j/n1*ton)).*p3b(s));
        else
            int2(j)=int2(j)+sum(k.^2.*alpha.*exp(-k.^2*((s-1)/(n2-1)*(toff-ton)+ton-j/n1*ton)).*p3b(s));
        end    
    end    
    int2(j)=int2(j)*(toff-ton)/(n2-1);
 end
 
 
 
 
 
 
% section a (0-ton):
%%%%%%%%%%%%%%%%%%%%%


 h(n1)     = w1a(1)-w0;
 h(2*n1)   = w2a(1)-wp0;
 h(3*n1)   = int1-Tmax;
for j=1:n1-1
    h(j)        = (w1a(j+1)-w1a(j))*(n1-1)/ton-w2a(j);    
    h(j+n1)     = (w2a(j+1)-w2a(j))*(n1-1)/ton-min(umax,max(-umax,-p2a(j)/lambda));
    h(j+2*n1)   = (p2a(j+1)-p2a(j))*(n1-1)/ton+p1+2*w2a(j)*(p3a*sum(alpha.*exp(-k.^2*ton*(1-j/n1)))-int2(j));   
end


 for j=1:n2
    int3(j)=0; % 1. Integral for w3b=Tmax 
    for s=1:n1
        if s==1
           int3(j)=int3(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton)));
        elseif s==n1
           int3(j)=int3(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton)));
        else
           int3(j)=int3(j)+sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton))); 
        end   
    end
    int3(j)=int3(j)/(n1-1)*ton;
 end
 
 
 int4(1)=0;
 for j=2:n2
     int4(j)=0;  % 2. Integral for w3b=Tmax
     for s=1:j
         if s==1
             int4(j)=int4(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));
         elseif s==j
             int4(j)=int4(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));  
         else    
             int4(j)=int4(j)+sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));
         end    
     end 
     int4(j)=int4(j)/(n2-1)*(toff-ton);
 end    
 
 
 int5(n2)=0;
 for j=1:n2-1
     int5(j)=0;  %  Integral for p2b dot
     for s=j:n2
         if s==j
             int5(j)=int5(j)+0.5*sum(k.^2.*alpha.*p3b(s).*exp(-k.^2*(s-j)/(n2-1)*(toff-ton)));   
         elseif s==n2    
             int5(j)=int5(j)+0.5*sum(k.^2.*alpha.*p3b(s).*exp(-k.^2*(s-j)/(n2-1)*(toff-ton)));
         else    
             int5(j)=int5(j)+sum(k.^2.*alpha.*p3b(s).*exp(-k.^2*(s-j)/(n2-1)*(toff-ton)));
         end
     end 
     int5(j)=int5(j)/(n2-1)*(toff-ton);
 end   


 
 
 
 
% section b (ton-toff):
%%%%%%%%%%%%%%%%%%%%%%%%


 h(3*n1+1)      = w1b(1)-w1a(n1);
 h(3*n1+n2+1)   = w2b(1)-w2a(n1);
 
for j=1:n2-1
    h(j+3*n1+1)      = (w1b(j+1)-w1b(j))*(n2-1)/(toff-ton)-w2b(j);
    h(j+3*n1+n2+1)   = (w2b(j+1)-w2b(j))*(n2-1)/(toff-ton)-min(umax,max(-umax,-p2b(j)/lambda));
    h(j+3*n1+2*n2)     = (p2b(j+1)-p2b(j))*(n2-1)/(toff-ton)+p1+2*w2b(j)*(p3b(j)-int5(j));
    h(j+3*n1+3*n2-1)   = (p3b(j+1)-p3b(j))*(n2-1)/(toff-ton)-mu;
end   
for j=1:n2
    h(j+3*n1+4*n2-2)   = int3(j)+int4(j)-Tmax;
end






% section c (toff-tf):
%%%%%%%%%%%%%%%%%%%%%%%


  h(3*n1+5*n2+n3-2)  = w1c(1)-w1b(n2);
  
  
for j=1:n3-1
    h(j+3*n1+5*n2-2)       = (w1c(j+1)-w1c(j))*(n3-1)/(tf-toff)-w2c(j);
    h(j+3*n1+5*n2+n3-2)    = (w2c(j+1)-w2c(j))*(n3-1)/(tf-toff)-min(umax,max(-umax,-p2c(j)/lambda));
    h(j+3*n1+5*n2+2*n3-3)  = (p2c(j+1)-p2c(j))*(n3-1)/(tf-toff)+p1;
end  

 h(3*n1+5*n2+3*n3-3) = w2c(1)-w2b(n2);
 h(3*n1+5*n2+3*n3-2) = w1c(n3);
 h(3*n1+5*n2+3*n3-1) = w2c(n3);

 
 
 
 
%Hamiltonian:
%%%%%%%%%%%%%%

h(3*n1+5*n2+3*n3)   = p2a(n1)-p2b(1);
h(3*n1+5*n2+3*n3+1) = p2b(n2)-p2c(1);
h(3*n1+5*n2+3*n3+2) = 1+0.5*lambda*min(umax,max(-umax,-p2c(n3)/lambda))^2+p1*w2c(n3)+p2c(n3)*min(umax,max(-umax,-p2c(n3)/lambda));



funktion=h;

















 