function  funktion1  = f1(x)
 
 global n1    % discretisation in time, variable j
 global n2    % discretisation in space, variable i

lambda=0.1;
umax=1;
w0=-6;
wp0=0;

for j=1:(n1+1)
    w1(j) = x(j);
    w2(j) = x(n1+1+j);
    p1(j) = x(2*n1+2+j);
    p2(j) = x(3*n1+3+j); 
end

tf = x(4*n1+5);  % endtime
 
% ODE + adjoint ODE 
for j=1:n1
    h(j)      = (w1(j+1)-w1(j))*n1/tf-w2(j);
    h(n1+j)   = (w2(j+1)-w2(j))*n1/tf-(max(min(umax,-1/lambda*p2(j)),-umax));
    h(2*n1+j) = (p1(j+1)-p1(j))*n1/tf;
    h(3*n1+j) = (p2(j+1)-p2(j))*n1/tf+p1(j);
end
 h(4*n1+1) = w1(1)-w0;
 h(4*n1+2) = w2(1)-wp0;
 h(4*n1+3) = w1(n1+1);
 h(4*n1+4) = w2(n1+1);


 h(4*n1+5) = 1+lambda/2*(max(min(umax,-1/lambda*p2(n1+1)),-umax))^2+w2(n1+1)*p1(n1+1)+(max(min(umax,-1/lambda*p2(n1+1)),-umax))*p2(n1+1);  % Hamiltonfunction at tend
 
funktion1=h;