function  funktion2  = f2(x)
 
global n1    % discretisation in time, variable j
global n2    % discretisation in space, variable i
 
lambda=0.1;
umax=1;
w0=-6;
wp0=0;

for j=1:(n1+1)
    w1(j) = x(j);
    w2(j) = x(n1+1+j);
    p1(j) = x(2*n1+2+j);
    p2(j) = x(3*n1+3+j);
    for i=1:(n2+1)
        T(i,j) = x(4*n1+5+(i-1)*(n1+1)+j);       
    end    
end

tf = x(4*n1+5);  % endtime
 
% ODE + adjoint ODE 
for j=1:n1
   h(j)      = (w1(j+1)-w1(j))*n1/tf-w2(j);
   h(n1+j)   = (w2(j+1)-w2(j))*n1/tf-(max(min(umax,-1/lambda*p2(j)),-umax));
   h(2*n1+j) = (p1(j+1)-p1(j))*n1/tf;
   h(3*n1+j) = (p2(j+1)-p2(j))*n1/tf+p1(j);
end
 h(4*n1+1) = w1(1)-w0;
 h(4*n1+2) = w2(1)-wp0;
 h(4*n1+3) = w1(n1+1);
 h(4*n1+4) = w2(n1+1);

 
 
 h(4*n1+5) = 1+lambda/2*(max(min(umax,-1/lambda*p2(n1+1)),-umax))^2+w2(n1+1)*p1(n1+1)+(max(min(umax,-1/lambda*p2(n1+1)),-umax))*p2(n1+1);  % Hamiltonfunction at tf
 
 % PDE
for j=1:n1
    for i=2:n2
       h(4*n1+5+(j-1)*(n2-1)+i-1) = (T(i,j+1)-T(i,j))*n1/tf-n2^2*0.5*(T(i-1,j+1)-2*T(i,j+1)+T(i+1,j+1)+T(i-1,j)-2*T(i,j)+T(i+1,j))-w2(j)^2;       
    end
end
for j=2:(n1+1)        % ingnore t=0, already covered with starting condition
    h(4*n1+5+n1*(n2-1)+j-1) = ( 3*T(n2,j)-4*T(n2-1,j)+T(n2-2,j))*n2/2+T(n2,j);
    h(5*n1+5+n1*(n2-1)+j-1) = (-3*T(1,j)+4*T(2,j)-T(3,j))*n2/2-T(1,j);
end
for i=1:(n2+1)
    h(6*n1+5+n1*(n2-1)+i) = T(i,1);
end 
 
funktion2=h;
