% =========================================================================
%  Plotting program for discr.txt, testing the effects of different
%  quadrature formulas for the objective functional
% =========================================================================



clear all
close all



format long e



% data input
% ===========


fid = fopen('y.txt');
a1 = textscan(fid, '%*f %f ','delimiter',',','headerlines', 1);
fclose(fid);
y=a1{1};

fid = fopen('u.txt');
a2 = textscan(fid, '%*f %f ','delimiter',',','headerlines', 1);
fclose(fid);
u=a2{1};



% plots
% ===========

figure
plot(linspace(0,1,max(size(u))),u);


figure
plot(linspace(0,1,max(size(y))),y);
